unit Mastermind;
{*****************************************************************************}
{                        PC als S U P E R H I R N                             }
{ Ziel war es, ein Programm zu entwickeln, das die vom Spieler gedachte Zahl  }
{ ermittelt, sofern die Angaben ber schwarze und weie Stifte stimmten.      }
{ Die Lsungsidee ist so einfach wie genial. Alle mglichen Kombinationen     }
{ aus Lochanzahl und Farbenzahl werden in einer Liste gespeichert. Per Zufall }
{ wird aus dieser Liste ein Versuch ausgewhlt. Die Information ber schwarze }
{ und weie Stifte durch den Spieler wird nun dazu verwendet, alle Kombina-   }
{ tionen aus der Liste zu streichen, die im Vergleich mit dem aktuellen Ver-  }
{ such NICHT das gleiche Ergebnis der Stifteanzahl ergeben!                   }
{*****************************************************************************}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

 const Max=15625;Maxstifte=6;Maxversuche=8;

type
  TFeld=ARRAY[1..Maxstifte]OF Byte;
  TSuperhirn = class(TForm)
    SpinEditLoch: TSpinEdit;
    LabelLoch: TLabel;
    SpinEditFarben: TSpinEdit;
    LabelFarben: TLabel;
    Start: TButton;
    LabelHinweis: TLabel;
    Rate: TButton;
    SpinEditSchwarz: TSpinEdit;
    LabelSchwarz: TLabel;
    SpinEditWeiss: TSpinEdit;
    LabelWeiss: TLabel;
    LabelErg: TLabel;
    Panel: TPanel;
    Bild: TImage;
    Timer: TTimer;
    FarbAnzeige: TImage;
    Ausgabe: TImage;
    SchmuAnzeige: TImage;
    Pruefen: TButton;
    procedure FormCreate(Sender: TObject);
    procedure SpinEditLochChange(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure RateClick(Sender: TObject);
    PROCEDURE GESCHUMMELT;
    procedure SpinEditSchwarzChange(Sender: TObject);
    procedure SpinEditFarbenChange(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure FarbAnzeigeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SchmuAnzeigeDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure SchmuAnzeigeDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure SchmuAnzeigeEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure PruefenClick(Sender: TObject);
    procedure SchmuAnzeigeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var Superhirn: TSuperhirn;

implementation

{$R *.DFM}
{$R MMCursor.RES}
{$R+,Q+}
 const crSuperhirn=1;

 var EINGABE:ARRAY[1..MAXVERSUCHE]OF TFeld;
     SFARB,WFARB:ARRAY[1..MAXVERSUCHE]OF Byte;
     ZUG:ARRAY[1..MAX]OF TFeld;
     Farbe,FarbListe:Array[1..9]of TColor;
     FERTIG,ZUENDE,Sperre:BOOLEAN;
     VERSUCH,Test:TFeld;
     IsDragging,IstGeprueft:Boolean;
     V,N,Loch,Farben,FarbNr:Byte;
     NMax:Word;

 procedure FarbenTausch;
  var L,M:Byte;
      T:TColor;
  begin
   L:=Random(9)+1;M:=Random(9)+1;
   T:=FarbListe[L];FarbListe[L]:=FarbListe[M];FarbListe[M]:=T
  end;

 procedure TSuperhirn.FormCreate(Sender: TObject);
  var K:Byte;
  begin
   Screen.Cursors[crSuperhirn]:=LoadCursor(HInstance,'DragCursor');
   FarbAnzeige.DragCursor:=crSuperhirn;
   SchmuAnzeige.DragCursor:=crSuperhirn;
   SchmuAnzeige.Visible:=False;
   Randomize;
   SpinEditSchwarz.Visible:=False;
   SpinEditWeiss.Visible:=False;
   LabelSchwarz.Visible:=False;
   LabelWeiss.Visible:=False;
   LabelErg.Visible:=False;
   Rate.Visible:=False;
   Pruefen.Visible:=False;
   Farbe[1]:=clWhite;Farbe[2]:=clRed;Farbe[3]:=clYellow;
   Farbe[4]:=clGreen;Farbe[5]:=clFuchsia;Farbe[6]:=clAqua;
   Farbe[7]:=clBlue;Farbe[8]:=clBlack;Farbe[9]:=clMaroon;
   FarbListe:=Farbe;
   LabelHinweis.Caption:='Denke dir eine Farbkombination'+#13+
    'bestehend aus '+IntToStr(SpinEditFarben.Value)+' Farben.'+#13+
    'Der PC versucht sie in'+#13+'maximal 8 Versuchen zu erraten!';
   with FarbAnzeige.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,FarbAnzeige.Width,FarbAnzeige.Height);
     Font.Style:=[fsBold];
     for K:=1 to SpinEditFarben.Value do
      begin
       Pen.Color:=clBlack;
       Brush.Style:=bsClear;
       TextOut(10+3*K+(K-1)*20,2,Char(48+K));
       Brush.Color:=Farbe[K];
       Ellipse(5+3*K+(K-1)*20,20,5+3*K+K*20,40);
      end;
    end;
   with Bild.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,Bild.Width,Bild.Height);
     Brush.Color:=Farbe[1];
     Ellipse(10,10,30,30);
     Brush.Color:=Farbe[2];
     Ellipse(50,15,70,35);
     Brush.Color:=Farbe[3];
     Ellipse(30,20,50,40);
     Brush.Color:=Farbe[4];
     Ellipse(5,50,25,70);
     Brush.Color:=Farbe[5];
     Ellipse(25,40,45,60);
     Brush.Color:=Farbe[6];
     Ellipse(50,50,70,70);
    end;
   with SchmuAnzeige.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,SchmuAnzeige.Width,SchmuAnzeige.Height);
    end   
  end;

 procedure TSuperhirn.SpinEditLochChange(Sender: TObject);
  begin
   if SpinEditLoch.Text='' then
    SpinEditLoch.Value:=SpinEditLoch.MinValue;
   if SpinEditLoch.Value<5 then SpinEditFarben.MaxValue:=9;
   if SpinEditLoch.Value=5 then
    begin
     SpinEditFarben.MaxValue:=6;
     if SpinEditFarben.Value>6 then SpinEditFarben.Value:=6;
    end;
   if SpinEditLoch.Value=6 then
    begin
     SpinEditFarben.MaxValue:=5;
     if SpinEditFarben.Value>5 then SpinEditFarben.Value:=5;
    end;
   LabelHinweis.Caption:='Denke dir eine Farbkombination'+#13+
    'bestehend aus '+IntToStr(SpinEditFarben.Value)+' Farben.'+#13+
    'Der PC versucht sie in'+#13+'maximal 8 Versuchen zu erraten!';
   Refresh;
  end;

 PROCEDURE INIT(Farben:Byte;NMax:Word);
  VAR AN:WORD;  { Aufstellen aller Kombinationen mit doppelten Steinen }
  PROCEDURE SETZ(L:BYTE);
   VAR K,G:BYTE;
   BEGIN
    FOR K:=1 TO FARBEN DO
     BEGIN
      ZUG[AN][L]:=K;
      IF L<LOCH THEN SETZ(L+1)
      ELSE IF AN<NMAX THEN
            BEGIN
             INC(AN);
             FOR G:=1 TO L-1 DO ZUG[AN][G]:=ZUG[AN-1][G]
            END
     END
   END;
  BEGIN
   Screen.Cursor:=crHourGlass;
   AN:=1;SETZ(1);
   Screen.Cursor:=crDefault;
  END;

 PROCEDURE VERGLEICHE(TEST,PROBE:TFELD;VAR S,W:BYTE);
  VAR K,L:BYTE;           { Anzahl der Stifte ermitteln }
  BEGIN
   W:=0;S:=0;
   FOR K:=1 TO LOCH DO IF TEST[K]=PROBE[K] THEN
    BEGIN INC(S);PROBE[K]:=0;TEST[K]:=0 END;
   FOR K:=1 TO LOCH DO
    Begin
     L:=0;
     while L<LOCH DO
      begin
       inc(L);
       IF (PROBE[L]>0) AND (TEST[K]=PROBE[L]) THEN
        BEGIN INC(W);PROBE[L]:=0;Break END // Aussprung aus der While - Schleife
      end
    end
  END;

 PROCEDURE PRUEFE(VAR VERSUCH:TFELD;VAR ENDE:BOOLEAN;SCHWARZ,WEISS:BYTE);
  VAR AN,K:WORD;
      S,W:BYTE;
  BEGIN
   AN:=0;
   FOR K:=1 TO NMAX DO
    IF ZUG[K][1]<255 THEN
     BEGIN
       { falls die aktuelle Kombination NICHT das gleiche Ergebnis liefert }
       { wie der Versuch, so wird sie gestrichen. }
      VERGLEICHE(VERSUCH,ZUG[K],S,W);
      IF (SCHWARZ<>S) OR (WEISS<>W) THEN ZUG[K][1]:=255
      ELSE INC(AN)
     END;
   IF AN=0 THEN ENDE:=TRUE
   ELSE
    BEGIN
     REPEAT K:=RANDOM(NMAX)+1 UNTIL ZUG[K][1]<255;
     VERSUCH:=ZUG[K]
    END
  END;

 procedure TSuperhirn.StartClick(Sender: TObject);
  var K:Byte;
      Zeile:String;
  begin
   FarbenTausch;
   SchmuAnzeige.Visible:=False;
   Pruefen.Visible:=False;
   IstGeprueft:=False;
   with Ausgabe.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,Ausgabe.Width,Ausgabe.Height);
    end;
   LabelErg.Caption:='';
   Sperre:=False;
   Loch:=SpinEditLoch.Value;
   Farben:=SpinEditFarben.Value;
   SpinEditLoch.Enabled:=False;
   SpinEditFarben.Enabled:=False;
   SpinEditSchwarz.MaxValue:=Loch;
   SpinEditSchwarz.Value:=0;
   SpinEditWeiss.MaxValue:=Loch;
   SpinEditWeiss.Value:=0;
   NMax:=1;
   FOR K:=1 TO LOCH DO NMAX:=NMAX*FARBEN;
   N:=LOCH+FARBEN;
   IF N>MAXVERSUCHE THEN N:=MAXVERSUCHE;
   INIT(Farben,NMax);
   LabelHinweis.Caption:='Denke dir eine Farbkombination'+#13+
    'bestehend aus '+IntToStr(SpinEditFarben.Value)+' Farben.'+#13+
    'Der PC versucht sie in'+#13+IntToStr(N)+' Versuchen zu erraten!';
   V:=0;FERTIG:=FALSE;ZUENDE:=FALSE;
   VERSUCH:=ZUG[RANDOM(NMAX)+1];
   INC(V);EINGABE[V]:=VERSUCH;
   with Ausgabe.Canvas do
    begin
     Pen.Color:=clBlack;
     Font.Style:=[fsBold];
     Brush.Style:=bsClear;
     Zeile:='';
     FOR K:=1 TO LOCH DO Zeile:=Zeile+IntToStr(VERSUCH[K])+' ';
     TextOut(3,2+3+(V-1)*30,Zeile);
     for K:=1 to Loch do
      begin
       Brush.Color:=Farbe[Eingabe[V,K]];
       Ellipse(80+(K-1)*20,3+(V-1)*30,80+K*20,3+(V-1)*30+20);
      end
    end;
   SpinEditSchwarz.Visible:=True;
   SpinEditWeiss.Visible:=True;
   LabelSchwarz.Visible:=True;
   LabelWeiss.Visible:=True;
   LabelErg.Visible:=True;
   Rate.Visible:=True;
   Start.Visible:=False;
  end;

 PROCEDURE TSuperhirn.GESCHUMMELT;
  VAR K:BYTE;
  begin
   SchmuAnzeige.Visible:=True;
   SpinEditLoch.Enabled:=False;
   SpinEditFarben.Enabled:=False;
   FillChar(Test,SizeOf(Test),0);
   with SchmuAnzeige.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,SchmuAnzeige.Width,SchmuAnzeige.Height);
     for K:=1 to Loch do
      begin
       Brush.Color:=clSilver;
       Ellipse(6,2*K+(K-1)*18,24,2*K+K*18);
      end;
    end;
  end;

 procedure TSuperhirn.PruefenClick(Sender: TObject);
  var K,L,S,W,Rechts:Byte;
      Zeile:String;
  begin
   Pruefen.Visible:=False;IstGeprueft:=True;
   SpinEditLoch.Enabled:=True;
   SpinEditFarben.Enabled:=True;
   K:=0;
   REPEAT
    INC(K);
    VERGLEICHE(TEST,EINGABE[K],S,W);
   UNTIL (S<>SFARB[K]) OR (W<>WFARB[K]);
   with Ausgabe.Canvas do
    begin
     Pen.Color:=clBlack;
     Font.Style:=[fsBold];
     Brush.Style:=bsSolid;
     Brush.Color:=clLime;
     Zeile:='';
     FOR L:=1 TO LOCH DO Zeile:=Zeile+IntToStr(EINGABE[K,L])+' ';
     TextOut(3,2+3+(K-1)*30,Zeile);
     Rechts:=0;
     if Loch=6 then
      begin
       Brush.Color:=clSilver;
       Pen.Color:=clSilver;
       Rectangle(80,3+(K-1)*30,Ausgabe.Width-2,3+(K-1)*30+20);
       Pen.Color:=clBlack;Rechts:=10;
      end;
     Font.Color:=clWhite;
     Brush.Color:=clBlack;
     TextOut(Length(Zeile)*6,2+3+(K-1)*30,IntToStr(SFARB[K]));
     Font.Color:=clBlack;
     Brush.Color:=clWhite;
     TextOut(Length(Zeile)*6+8,2+3+(K-1)*30,IntToStr(WFARB[K]));
     for L:=1 to Loch do
      begin
       Brush.Color:=Farbe[Eingabe[K,L]];
       Ellipse(80+Rechts+(L-1)*20,3+(K-1)*30,80+Rechts+L*20,3+(K-1)*30+20);
      end
    end;
  END;

 procedure TSuperhirn.RateClick(Sender: TObject);
  var K,Schwarz,Weiss:Byte;
      Zeile:String;
  begin
   if (V<N) AND NOT FERTIG AND NOT ZUENDE then
    begin
     Schwarz:=SpinEditSchwarz.Value;
     Weiss:=SpinEditWeiss.Value;
     SFARB[V]:=SCHWARZ;WFARB[V]:=WEISS;
     IF SCHWARZ=LOCH-1 THEN WEISS:=0;
     IF SCHWARZ=LOCH THEN FERTIG:=TRUE
     ELSE PRUEFE(VERSUCH,ZUENDE,SCHWARZ,WEISS);
     IF FERTIG THEN
      Begin
       LabelErg.Caption:='Der schlaue PC hat die Zahl erraten !';
       Start.Visible:=True;
       Sperre:=True;
      End;
     IF ZUENDE THEN
      BEGIN
       LabelErg.Caption:='Du hast geschummelt!'+#13+
                         'Gib deine Farbkombination ein!';
       GESCHUMMELT;
       Start.Visible:=True;
       Sperre:=True;
      END;
     if V=N then
      Begin
       LabelErg.Caption:='Der PC hat versagt!';
       Start.Visible:=True;
       Sperre:=True;
      End;
     if (V<N) AND NOT FERTIG AND NOT ZUENDE then
      begin
       INC(V);EINGABE[V]:=VERSUCH;
       with Ausgabe.Canvas do
        begin
         Pen.Color:=clBlack;
         Font.Style:=[fsBold];
         Brush.Style:=bsClear;
         Zeile:='';
         FOR K:=1 TO LOCH DO Zeile:=Zeile+IntToStr(VERSUCH[K])+' ';
         TextOut(3,2+3+(V-1)*30,Zeile);
         for K:=1 to Loch do
          begin
           Brush.Color:=Farbe[Eingabe[V,K]];
           Ellipse(80+(K-1)*20,3+(V-1)*30,80+K*20,3+(V-1)*30+20);
          end
        end;
      end;
    end;
   if Sperre then
    begin
     SpinEditSchwarz.Visible:=False;
     SpinEditWeiss.Visible:=False;
     LabelSchwarz.Visible:=False;
     LabelWeiss.Visible:=False;
     Rate.Visible:=False;
     SpinEditLoch.Enabled:=True;
     SpinEditFarben.Enabled:=True;
    end;
  end;

 procedure TSuperhirn.SpinEditSchwarzChange(Sender: TObject);
  begin
   SpinEditWeiss.Value:=Loch-SpinEditSchwarz.Value;
  end;

 procedure TSuperhirn.SpinEditFarbenChange(Sender: TObject);
  var K:Byte;
  begin
   if SpinEditFarben.Text='' then
    SpinEditFarben.Value:=SpinEditFarben.MinValue;
   with FarbAnzeige.Canvas do
    begin
     Brush.Color:=clSilver;
     Rectangle(0,0,FarbAnzeige.Width,FarbAnzeige.Height);
     Font.Style:=[fsBold];
     for K:=1 to SpinEditFarben.Value do
      begin
       Pen.Color:=clBlack;
       Brush.Style:=bsClear;
       TextOut(10+3*K+(K-1)*20,2,Char(48+K));
       Brush.Color:=Farbe[K];
       Ellipse(5+3*K+(K-1)*20,20,5+3*K+K*20,40);
      end;
    end;
   LabelHinweis.Caption:='Denke dir eine Farbkombination'+#13+
    'bestehend aus '+IntToStr(SpinEditFarben.Value)+' Farben.'+#13+
    'Der PC versucht sie in'+#13+'maximal 8 Versuchen zu erraten!';
  end;

 procedure TSuperhirn.TimerTimer(Sender: TObject);
  var T:TColor;
      K:Byte;
  begin
   with Bild.Canvas do
    begin
     T:=FarbListe[1];
     for K:=1 to 5 do FarbListe[K]:=FarbListe[K+1];
     FarbListe[6]:=T;
     Brush.Color:=FarbListe[1];
     Ellipse(10,10,30,30);
     Brush.Color:=FarbListe[2];
     Ellipse(50,15,70,35);
     Brush.Color:=FarbListe[3];
     Ellipse(30,20,50,40);
     Brush.Color:=FarbListe[4];
     Ellipse(5,50,25,70);
     Brush.Color:=FarbListe[5];
     Ellipse(25,40,45,60);
     Brush.Color:=FarbListe[6];
     Ellipse(50,50,70,70);
    end;
  end;

 procedure TSuperhirn.FarbAnzeigeMouseDown(Sender: TObject;
                      Button: TMouseButton; Shift: TShiftState; X,Y:Integer);
  begin
   if (Button=mbLeft) and Not IstGeprueft then
    begin
     FarbNr:=(X+15)div 23;
     if (FarbNr>0) and (FarbNr<=Farben) then
      begin
       IsDragging:=True;
       FarbAnzeige.BeginDrag(True);
      end
    end
  end;

 procedure TSuperhirn.SchmuAnzeigeDragOver(Sender, Source: TObject; X,
                      Y: Integer; State: TDragState; var Accept: Boolean);
  begin
   Accept:=False;
   if ((Source is TImage) and (TImage(Source).Name='FarbAnzeige') and
      (Sender is TImage) and (TImage(Sender).Name='SchmuAnzeige')) or
      ((Source is TImage) and (TImage(Source).Name='SchmuAnzeige') and
      (Sender is TImage) and (TImage(Sender).Name='SchmuAnzeige')) then
      Accept:=(11<=X) and (X<=19) and
              (6<Y mod 20) and (Y mod 20<16) and ((Y+18)div 20<=Loch);
  end;

 procedure TSuperhirn.SchmuAnzeigeDragDrop(Sender,Source:TObject;X,Y:Integer);
  var K,L,N:Byte;
  begin
   K:=(Y+18)div 20;
   Test[K]:=FarbNr;
   with SchmuAnzeige.Canvas do
    begin
     Brush.Color:=Farbe[FarbNr];
     Ellipse(6,2*K+(K-1)*18,24,2*K+K*18);
    end;
   N:=0;
   for L:=1 to Loch do
    if Test[L]>0 then inc(N);
   if N=Loch then Pruefen.Visible:=True;
  end;

 procedure TSuperhirn.SchmuAnzeigeEndDrag(Sender,Target:TObject;X,Y:Integer);
  begin
   if IsDragging then IsDragging:=False;
  end;

 procedure TSuperhirn.SchmuAnzeigeMouseDown(Sender: TObject;
                      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var Nr:Byte;
  begin
   if (Button=mbLeft) and Not IstGeprueft then
    begin
     Nr:=(Y+18)div 20;
     if (Test[Nr]>0) and (Test[Nr]<=Farben) then
      begin
       FarbNr:=Test[Nr];
       IsDragging:=True;
       SchmuAnzeige.BeginDrag(True);
      end
    end
  end;

end.

  

